#include <Agents/Perception/Perception.hpp>
#include <Environment/PictureEnvironment.hpp>

int PERCEPTION_SIZE = 4;

PictureEnvironment::PictureEnvironment()
{
}

PictureEnvironment::PictureEnvironment(std::string& iFilePath, sf::RenderWindow* iWindow)
{
	fFilePath = iFilePath;

	//memccpy(&fFilePath, &iFilePath, *iFilePath., 10);
	std::cout << "Environement pour " << fFilePath;

	fWindow = iWindow;

	fShape = sf::CircleShape(fWindow->getSize().x / 2);
	fShape.setFillColor(sf::Color::White);

	sf::Texture shapeTexture;
	if (!shapeTexture.loadFromFile(fFilePath))
	{
		std::cout << "\n COULDNT LOAD PICTURE\n";
	}
	fShape.setTexture(&shapeTexture);
}

Perception PictureEnvironment::getPerception(int iX, int iY)
{
	Perception vPerception = Perception(PERCEPTION_SIZE, PERCEPTION_SIZE);
	iX++;
	iY++;
	return vPerception;
}

bool PictureEnvironment::loop()
{
	if (fWindow->isOpen())
	{
		while (fWindow->pollEvent(fEvent))
		{
			if (fEvent.type == sf::Event::Closed)
				fWindow->close();
		}
		fShape = sf::CircleShape(fWindow->getSize().x / 2);
		fShape.setFillColor(sf::Color::White);

		sf::Texture shapeTexture;
		if (!shapeTexture.loadFromFile(fFilePath))
		{
			std::cout << "\n COULDNT LOAD PICTURE\n";
		}
		fShape.setTexture(&shapeTexture);

		fWindow->clear();
		fWindow->draw(fShape);
		fWindow->display();
	}
	else
	{
		std::cout << "\nBah on ferme";
		return false;
	}
	return true;
}